package adproject;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Toolkit;
import javax.swing.JOptionPane;

/**
 *
 * @author "Ahmad Dehnavi"
 */
public class WoodCanvas extends Canvas {

    private static WoodCanvas w;
    private Image img;
    private final int length;
    private int[] cutPoints;
    private int[] RcutPoints;//real
    private boolean startCutting = false;
    private float meghias;
    private long sleepTime = 1000;

    public long getSleepTime() {
        return sleepTime;
    }

    public void setSleepTime(long sleepTime) {
        this.sleepTime = sleepTime;
    }

    public WoodCanvas(int length) {
        this.length = length;
        try{
        img =Toolkit.getDefaultToolkit().getImage(getClass().getResource("/wood.JPG"));
        }catch(Exception e){JOptionPane.showMessageDialog(null, "Can Not Load Image File.");
        }
    }

    public int getLength() {
        return length;
    }

    @Override
    public void paint(Graphics g) {

        
        
        this.meghias = (float) this.getWidth() / this.length;
        int x = length / 20;
        if (x < 1) {
            x = 1;
        }

        if (meghias < 0.5) {
            x *= 2;
        }
        for (int i = 0, j; i < length; i += x) {

            j = (int) (i * this.meghias);
            g.drawString(i + "", j, 15);
            g.drawLine(j, 0, j, 10);
            i += x;
            j = (int) (i * this.meghias);
            g.drawLine(j, 0, j, 5);

        }
        boolean drawed = g.drawImage(this.img, 0, 20, this.getWidth(), 20, this);

        if (drawed && startCutting) {
            for (int i = 0; i < cutPoints.length; i++) {
                try {
                    Thread.sleep(this.sleepTime);
                } catch (Exception ex) {
                }
                g.setColor(Color.WHITE);
                g.fillRect(cutPoints[i], 20, 2, 20);
                g.setColor(Color.red);
                g.drawString("" + RcutPoints[i], cutPoints[i], 60);


            }
            this.startCutting = false;
        }

    }

    private void updateCutPoint() {
        if (meghias == 0) {
            meghias = 1;
        }

        cutPoints = new int[RcutPoints.length];
        for (int i = 0; i < cutPoints.length; i++) {
            cutPoints[i] = (int) (RcutPoints[i] * meghias);

        }

    }

    public void startCutting() {
        updateCutPoint();
        this.startCutting = true;
        this.repaint();
    }

    public void setCutPoints(int[] cutPoints) {
        this.RcutPoints = cutPoints;
    }
}
